import java.awt.GridLayout;

import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;
import javax.swing.JRadioButton;
import javax.swing.JSlider;
import javax.swing.JTabbedPane;
import javax.swing.JTable;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.JToggleButton;
import javax.swing.JToolBar;
import javax.swing.JTree;
import javax.swing.border.TitledBorder;

public class PopupMenuSample2 {
    private JPopupMenu popupMenu;

    public PopupMenuSample2() {
        JFrame frame = new JFrame("PopupMenu Sample");
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frame.setLocationByPlatform(true);
        frame.setSize(600, 600);
        frame.setLayout(new GridLayout(0, 2));
        
        popupMenu = new JPopupMenu();
        popupMenu.add(new JMenuItem("item 1"));
        popupMenu.add(new JMenuItem("item 2"));
        popupMenu.add(new JMenuItem("item 3"));

        JMenuBar menuBar = new JMenuBar();
        menuBar.add(createMenu(1));
        menuBar.add(createMenu(2));
        menuBar.setComponentPopupMenu(popupMenu);
        frame.setJMenuBar(menuBar);

        JButton button = new JButton("Button");
        button.setComponentPopupMenu(popupMenu);
        button.setBorder(new TitledBorder("JButton"));
        frame.getContentPane().add(button);

        JCheckBox checkBox = new JCheckBox("CheckBox");
        checkBox.setComponentPopupMenu(popupMenu);
        checkBox.setBorder(new TitledBorder("JCheckBox"));
        frame.getContentPane().add(checkBox);

        JComboBox comboBox = new JComboBox(new String[]{"item1", "item2"});
        comboBox.setComponentPopupMenu(popupMenu);
        comboBox.setBorder(new TitledBorder("JComboBox"));
        frame.getContentPane().add(comboBox);

        JLabel label = new JLabel("Label");
        label.setComponentPopupMenu(popupMenu);
        label.setBorder(new TitledBorder("JLabel"));
        frame.getContentPane().add(label);

        JList list = new JList(new String[]{"label1", "label2"});
        list.setComponentPopupMenu(popupMenu);
        list.setBorder(new TitledBorder("JList"));
        frame.getContentPane().add(list);

        JPanel panel = new JPanel();
        panel.setComponentPopupMenu(popupMenu);
        panel.setBorder(new TitledBorder("JPanel"));
        frame.getContentPane().add(panel);

        JRadioButton radioButton = new JRadioButton("RadioButton");
        radioButton.setComponentPopupMenu(popupMenu);
        radioButton.setBorder(new TitledBorder("JRadioButton"));
        frame.getContentPane().add(radioButton);

        JSlider slider = new JSlider();
        slider.setComponentPopupMenu(popupMenu);
        slider.setBorder(new TitledBorder("JSlider"));
        frame.getContentPane().add(slider);

        JTabbedPane tabbedPane = new JTabbedPane();
        tabbedPane.add("Tab1", new JPanel());
        tabbedPane.setComponentPopupMenu(popupMenu);
        tabbedPane.setBorder(new TitledBorder("JTabbedPane"));
        frame.getContentPane().add(tabbedPane);

        JTable table = new JTable(2, 2);
        table.setComponentPopupMenu(popupMenu);
        table.setBorder(new TitledBorder("JTable"));
        frame.getContentPane().add(table);

        JTextArea area = new JTextArea();
        area.setComponentPopupMenu(popupMenu);
        area.setBorder(new TitledBorder("JTextArea"));
        frame.getContentPane().add(area);

        JTextField field = new JTextField();
        field.setComponentPopupMenu(popupMenu);
        field.setBorder(new TitledBorder("JTextField"));
        frame.getContentPane().add(field);

        JToggleButton toggleButton = new JToggleButton("ToggleButton");
        toggleButton.setComponentPopupMenu(popupMenu);
        toggleButton.setBorder(new TitledBorder("JToggleButton"));
        frame.getContentPane().add(toggleButton);

        JToolBar toolBar = new JToolBar();
        toolBar.add(new JButton("item1"));
        toolBar.add(new JButton("item2"));
        toolBar.setComponentPopupMenu(popupMenu);
        toolBar.setBorder(new TitledBorder("JToolBar"));
        frame.getContentPane().add(toolBar);

        JTree tree = new JTree(new String[]{"Tree1", "Tree2"});
        tree.setComponentPopupMenu(popupMenu);
        tree.setBorder(new TitledBorder("JTree"));
        frame.getContentPane().add(tree);

        frame.setVisible(true);
    }

    private JMenu createMenu(int i) {
        JMenu menu = new JMenu("menu" + i);
        menu.setComponentPopupMenu(popupMenu);
        JMenuItem item = new JMenuItem("item" + i);
        item.setComponentPopupMenu(popupMenu);
        menu.add(item);

        return menu;
    }

    public static void main(String[] args) {
        new PopupMenuSample2();
    }
}
